import { AsyncSeriesWaterfallHook } from 'tapable';
import { addHooks, createRootPlugin } from '@sewing-kit/plugin-utilities';
var PLUGIN = 'SewingKit.babel';
var addBabelHooks = addHooks(function () {
  return {
    babelConfig: new AsyncSeriesWaterfallHook(['babelConfig'])
  };
});
export default createRootPlugin(PLUGIN, function (tasks) {
  tasks.build.tap(PLUGIN, function (_ref) {
    var hooks = _ref.hooks;
    hooks["package"].tap(PLUGIN, function (_ref2) {
      var hooks = _ref2.hooks;
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
    hooks.webApp.tap(PLUGIN, function (_ref3) {
      var hooks = _ref3.hooks;
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
  });
  tasks.test.tap(PLUGIN, function (_ref4) {
    var hooks = _ref4.hooks;
    hooks.project.tap(PLUGIN, function (_ref5) {
      var hooks = _ref5.hooks;
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
  });
});