function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { resolve } from 'path';
import { createStep, MissingPluginError } from '@sewing-kit/ui';
import { toArgs } from '@sewing-kit/plugin-utilities';
var PRESET_MATCHER = /(babel-preset-shopify(?:\/[^.]*)?)/;

function normalizePreset(preset) {
  var match = preset.match(PRESET_MATCHER);
  return match ? match[1].replace('/index', '') : preset;
}

function createCheck(test) {
  return function (preset) {
    var normalized = normalizePreset(preset);
    return typeof test === 'string' ? test === normalized : test.some(function (test) {
      return test === normalized;
    });
  };
}

export function changeBabelPreset(from, to) {
  var check = createCheck(from);
  return function (_ref) {
    var _ref$presets = _ref.presets,
        presets = _ref$presets === void 0 ? [] : _ref$presets;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = presets.entries()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _step$value = _slicedToArray(_step.value, 2),
            index = _step$value[0],
            preset = _step$value[1];

        if (typeof preset === 'string') {
          if (check(preset)) {
            presets[index] = to;
          }
        } else if (check(preset[0])) {
          preset[0] = to;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator["return"] != null) {
          _iterator["return"]();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  };
}
export function updateBabelPreset(match, options) {
  var check = createCheck(match);
  return function (_ref2) {
    var _ref2$presets = _ref2.presets,
        presets = _ref2$presets === void 0 ? [] : _ref2$presets;
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = presets.entries()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var _step2$value = _slicedToArray(_step2.value, 2),
            index = _step2$value[0],
            preset = _step2$value[1];

        if (typeof preset === 'string') {
          if (check(preset)) {
            presets[index] = [preset, options];
          }
        } else if (check(preset[0])) {
          preset[1] = _objectSpread({}, preset[1], {}, options);
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
          _iterator2["return"]();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }
  };
}
export function createCompileBabelStep(pkg, workspace, config, options) {
  return createStep(
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(step) {
      var _options$configFile, configFile, outputPath, babelConfigPath, extensions, sourceRoot;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _options$configFile = options.configFile, configFile = _options$configFile === void 0 ? 'babel.js' : _options$configFile, outputPath = options.outputPath;
              babelConfigPath = workspace.internal.configPath("build/packages/".concat(pkg.name, "/").concat(configFile));

              if (!(config.babelConfig == null)) {
                _context.next = 4;
                break;
              }

              throw new MissingPluginError('@sewing-kit/plugin-babel');

            case 4:
              _context.t0 = workspace.internal;
              _context.t1 = babelConfigPath;
              _context.t2 = "module.exports=";
              _context.t3 = JSON;
              _context.next = 10;
              return config.babelConfig.promise({
                presets: []
              });

            case 10:
              _context.t4 = _context.sent;
              _context.t5 = _context.t3.stringify.call(_context.t3, _context.t4);
              _context.t6 = _context.t2.concat.call(_context.t2, _context.t5, ";");
              _context.next = 15;
              return _context.t0.write.call(_context.t0, _context.t1, _context.t6);

            case 15:
              _context.next = 17;
              return config.extensions.promise([]);

            case 17:
              extensions = _context.sent;
              sourceRoot = resolve(pkg.root, 'src');
              _context.next = 21;
              return step.exec('node_modules/.bin/babel', [sourceRoot].concat(_toConsumableArray(toArgs({
                outDir: outputPath,
                configFile: babelConfigPath,
                verbose: true,
                noBabelrc: true,
                extensions: extensions.join(',')
              }, {
                dasherize: true
              }))));

            case 21:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref3.apply(this, arguments);
    };
  }());
}